/*++

Copyright: Jan Krynicky <Jenda@Krynicky.cz>

Session id in URL : http://www.server.com/ID:whateverIDyoulike/path/to/script.cgi

--*/

#include <windows.h>
#include <httpfilt.h>
#include "SessionID.h"


 void WriteToFile (char *szFormat, ...) {
  char szBuf[1024];
  HANDLE hFile;
  DWORD dwWritten;
  va_list list;
  va_start (list, szFormat);
  vsprintf (szBuf, szFormat, list);
  hFile = CreateFile (LOGFILE, GENERIC_WRITE, 
       0, NULL, OPEN_ALWAYS, 
       FILE_ATTRIBUTE_NORMAL, NULL);
  if (hFile != INVALID_HANDLE_VALUE) {
   SetFilePointer (hFile, 0, NULL, FILE_END);
   WriteFile (hFile, szBuf, lstrlen (szBuf), &dwWritten, NULL);
   CloseHandle (hFile);
  }
  va_end (list);
 }


BOOL
WINAPI
DllMain(
     IN HINSTANCE hinstDll,
     IN DWORD     fdwReason,
     IN LPVOID    lpvContext OPTIONAL
     )
/*++

 Routine Description:

   This function DllLibMain() is the main initialization function for
    this DLL. It initializes local variables and prepares it to be invoked
    subsequently.

 Arguments:

   hinstDll          Instance Handle of the DLL
   fdwReason         Reason why NT called this DLL
   lpvReserved       Reserved parameter for future use.

 Return Value:

    Returns TRUE is successful; otherwise FALSE is returned.
--*/
{
    BOOL        fReturn = TRUE;

    switch (fdwReason )
    {
    case DLL_PROCESS_ATTACH:

        //
        //  We don't care about thread attach/detach notifications
        //

        DisableThreadLibraryCalls( hinstDll );

		    DbgWrite(( "[GetFilterVersion] SessionID filter loading\n"));

        break;

//    case DLL_PROCESS_DETACH: // no need to do anything

    default:
        break;
    }   /* switch */

    return ( fReturn);
}  /* DllLibMain() */


BOOL 
WINAPI
GetFilterVersion(
    HTTP_FILTER_VERSION * pVer
    )
{
    DbgWrite(( "[GetFilterVersion] Called\n" ));

    DbgWrite(( "[GetFilterVersion] SessionID filter version is %d.%d\n",
               HIWORD( pVer->dwServerFilterVersion ),
               LOWORD( pVer->dwServerFilterVersion ) ));

    pVer->dwFilterVersion = HTTP_FILTER_REVISION;

    //
    //  Specify the types and order of notification
    //

    pVer->dwFlags = (SF_NOTIFY_SECURE_PORT        |
                     SF_NOTIFY_NONSECURE_PORT     |

                     SF_NOTIFY_PREPROC_HEADERS	  |

                     SF_NOTIFY_ORDER_HIGH);

    lstrcpy( pVer->lpszFilterDesc, "SessionID Filter by http://Jenda.Krynicky.cz" );

	DbgWrite(( "[GetFilterVersion] Finished %d\n" , pVer->dwFlags));

    return TRUE; 
}

char *string_url = "url";
// char *string_url = "Host:";
char *string_session = "SessionID:";

DWORD
WINAPI
HttpFilterProc(
    HTTP_FILTER_CONTEXT *      pfc,
    DWORD                      NotificationType,
    VOID *                     pvData
    )
/*++

Routine Description:

    Filter notification entry point

Arguments:

    pfc -              Filter context
    NotificationType - Type of notification
    pvData -           Notification specific data

Return Value:

    One of the SF_STATUS response codes

--*/
{
	HTTP_FILTER_PREPROC_HEADERS * pHdr = pvData;
	CHAR SessionID[256];
		char url[1024];
		DWORD len = 1023;
		char *url_pos;

	//
	//  Handle this notification
	//

DbgWrite(("[HttpFilterProc] notified ...\n"));

	switch ( NotificationType )
	{
	case SF_NOTIFY_PREPROC_HEADERS:

		// snip the ID

		pHdr->GetHeader( pfc, string_url, url, &len);

		if (url[0] != 0) {
			url_pos = url;

//DbgWrite(( "Processing URL: %s\n", url));
DbgWrite(( "Path: %s\n", url_pos));

			if ((url_pos == 0) || (url_pos[0] == 0) || (url_pos[1] == 0)) {
DbgWrite(( "Empty path\n"));
				return SF_STATUS_REQ_NEXT_NOTIFICATION;
			}
			 // za servername nic neni

			SessionID[255] = 0; // priprava zarazky

			if (url_pos[1] == 'I' && url_pos[2] == 'D' && url_pos[3] == ':') {

				char *path_pos;

DbgWrite(( "There IS the /ID: in: %s\n", url_pos));

				if ((path_pos = strchr(url_pos+4, '/')) == 0 
				&&  (path_pos = strchr(url_pos+4, '?')) == 0) { // za Session IDem uz neni nic

DbgWrite(( "Nothing found after the ID: %s\n", url_pos));

					strncpy(SessionID, url_pos+4, 255);
					url_pos[0] = 0;

DbgWrite(( "Session: %s\n\n", SessionID));

				} else { // url_pos ukazuje na ID: a path_pos za ID:...

DbgWrite(( "Rest of path: %s\n", path_pos));

					strncpy(SessionID,url_pos+4, __min((path_pos-url_pos)-4, 255));
					SessionID[ __min((path_pos-url_pos)-4, 255) ] = 0;
					strcpy(url_pos, path_pos);

DbgWrite(( "Session: %s\n\n", SessionID));

				}

				pHdr->SetHeader( pfc, string_url, url);
				pHdr->AddHeader( pfc, string_session, SessionID);
			}

		} else {
	        DbgWrite(("[HttpFilterProc] GetHeader() did not return the URL, %d\n",
			        GetLastError()));
	        DbgWrite(("[HttpFilterProc]          %s\n",
			        url));
		}

		break;

    default:
        DbgWrite(("[HttpFilterProc] Unknown notification type, %d\n", NotificationType ));

        break;
    }

    return SF_STATUS_REQ_NEXT_NOTIFICATION;
}

BOOL
WINAPI  
TerminateFilter(
    DWORD dwFlags
    ) {
DbgWrite(("[TerminateFilter] called ...\n"));
	return TRUE;
}
